/* Lehasoft Tetris Mobile 2006
   Copyright (c) Alexey Inkin, Lehasoft (1996-2006), GetSoft.ru, leha@inkin.ru

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  */

package Game;

class PauseWaiter
{
    private int m_nState;
    
    private final static int    STATE_ACTIVE    = 1;
    private final static int    STATE_PAUSED    = 3;
    
    public PauseWaiter()
    {
        m_nState = STATE_PAUSED;
    }
    
    public synchronized void pause()
    {
        m_nState = STATE_PAUSED;
    }
    
    public synchronized void resume()
    {
        m_nState = STATE_ACTIVE;
        notify();
    }
    
    public synchronized void waitForPauseCanceled()
    {
        try
        {
            if (m_nState == STATE_PAUSED)
                wait();
        }
        catch (Exception e)
        {
            System.out.println(e);
        }
    }
}