/* Lehasoft Tetris Mobile 2006
   Copyright (c) Alexey Inkin, Lehasoft (1996-2006), GetSoft.ru, leha@inkin.ru

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  */

package Game;

import java.io.*;
import javax.microedition.media.*;
import javax.microedition.media.control.*;

public class Sounder
{
    private Player          m_objCutLinesPlayer;
    private Player          m_objDropPlayer;
    private Player          m_objGameOverPlayer;
    private VolumeControl   m_objCutLinesVolumeControl;
    private VolumeControl   m_objDropVolumeControl;
    private VolumeControl   m_objGameOverVolumeControl;

    public Sounder()
    {
        try
        {
            InputStream is;
            
            is = getClass().getResourceAsStream("/Sound/cut_lines.mp3");
            m_objCutLinesPlayer = Manager.createPlayer(is, "audio/mpeg");
            m_objCutLinesPlayer.realize();
            m_objCutLinesVolumeControl = (VolumeControl)m_objCutLinesPlayer.getControl("VolumeControl");
            
            is = getClass().getResourceAsStream("/Sound/drop.mp3");
            m_objDropPlayer = Manager.createPlayer(is, "audio/mpeg");
            m_objDropPlayer.realize();
            m_objDropVolumeControl = (VolumeControl)m_objDropPlayer.getControl("VolumeControl");
            
            is = getClass().getResourceAsStream("/Sound/game_over.mp3");
            m_objGameOverPlayer = Manager.createPlayer(is, "audio/mpeg");
            m_objGameOverPlayer.realize();
            m_objGameOverVolumeControl = (VolumeControl)m_objGameOverPlayer.getControl("VolumeControl");
        }
        catch (Exception e)
        {
            System.out.println(e);
        }
    }
    
    public void onCutLines()
    {
        try
        {
            if (m_objCutLinesPlayer != null)
                m_objCutLinesPlayer.start();
        }
        catch (Exception e)
        {
            System.out.println(e);
        }
    }
    
    public void onDrop()
    {
        try
        {
            if (m_objDropPlayer != null)
                m_objDropPlayer.start();
        }
        catch (Exception e)
        {
            System.out.println(e);
        }
    }
    
    public void onGameOver()
    {
        try
        {
            if (m_objGameOverPlayer != null)
                m_objGameOverPlayer.start();
        }
        catch (Exception e)
        {
            System.out.println(e);
        }
    }
    
    public void setMute(boolean b)
    {
        if (m_objCutLinesVolumeControl != null)
        {
            try
            {
                m_objCutLinesVolumeControl.setMute(b);
                m_objDropVolumeControl.setMute(b);
                m_objGameOverVolumeControl.setMute(b);
            }
            catch (Exception e)
            {
                System.out.println(e);
            }
        }
    }
    
    public void setVolume(int n)
    {
        if (m_objCutLinesVolumeControl != null)
        {
            try
            {
                m_objCutLinesVolumeControl.setLevel(n);
                m_objDropVolumeControl.setLevel(n);
                m_objGameOverVolumeControl.setLevel(n);
            }
            catch (Exception e)
            {
                System.out.println(e);
            }
        }
    }
}
