/* Lehasoft Tetris Mobile 2006
   Copyright (c) Alexey Inkin, Lehasoft (1996-2006), GetSoft.ru, leha@inkin.ru

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  */

package Interface;

import Main.*;
import javax.microedition.lcdui.*;

public class PreferencesMenu extends List implements CommandListener, Localizable
{
    private Tetris      m_objApplication;
    private Localizer   m_objLocalizer;
    
    private Command     m_cmdBack;
    
    public PreferencesMenu(Tetris objApplication, Localizer objLocalizer)
    {
        super(objLocalizer.get(Localizer.S_PREFERENCES), IMPLICIT);
        
        m_objApplication = objApplication;
        m_objLocalizer = objLocalizer;

        setCommandListener(this);
        //addCommand(m_cmdBack);
        addCommand(SELECT_COMMAND);
        localize();
    }
    
    public void commandAction(Command cmd, Displayable d)
    {
        if (cmd == m_cmdBack)
            m_objApplication.onBack();
        else
        {
            switch (getSelectedIndex())
            {
                case 0:
                    m_objApplication.onBricksColor(this);
                    break;
                case 1:
                    m_objApplication.onSoundPreferences(this);
                    break;
                case 2:
                    m_objApplication.onLanguage(this);
            }
        }
    }
    
    public void localize()
    {
        setTitle(m_objLocalizer.get(Localizer.S_PREFERENCES));
        refillMenu();
        
        if (m_cmdBack != null)
            removeCommand(m_cmdBack);
        m_cmdBack = new Command(m_objLocalizer.get(Localizer.S_BACK), Command.BACK, 0);
        addCommand(m_cmdBack);
    }

    private void refillMenu()
    {
        deleteAll();
        
        append(m_objLocalizer.get(Localizer.S_BRICK_COLOR), null);
        append(m_objLocalizer.get(Localizer.S_SOUND), null);
        append(m_objLocalizer.get(Localizer.S_LANGUAGE), null);
    }
}