/* Lehasoft Tetris Mobile 2006
   Copyright (c) Alexey Inkin, Lehasoft (1996-2006), GetSoft.ru, leha@inkin.ru

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  */

package Interface;

import Main.NonReentrantMutex;

class SideMessageTicker implements Runnable
{
    private TetrisCanvas        m_objTetrisCanvas;
    private Thread              m_objThread;
    private NonReentrantMutex   m_objMutex = new NonReentrantMutex();
    
    private static final int    nTimerInterval = 1000;
    
    public SideMessageTicker(TetrisCanvas tc)
    {
        m_objTetrisCanvas = tc;
        m_objMutex.p();
    }
    
    public void run()
    {
        while (true)
        {
            try
            {
                synchronized (this)
                {
                    wait(nTimerInterval);
                }
            }
            catch (InterruptedException e)
            {
            }
            m_objTetrisCanvas.clearSideMessage();
            m_objMutex.p();
            synchronized (this)
            {
                notify();
            }
            m_objMutex.v();
        }
    }
    
    public synchronized void startTimer()
    {
        if (m_objThread == null)
        {
            m_objThread = new Thread(this);
            m_objThread.start();
        }
        else
        {
            m_objMutex.v();
            notify();
            try
            {
                wait();
            }
            catch (InterruptedException e)
            {
            }
            m_objMutex.p();
        }
    }
}