/* Lehasoft Tetris Mobile 2006
   Copyright (c) Alexey Inkin, Lehasoft (1996-2006), GetSoft.ru, leha@inkin.ru

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  */

package Interface;

import Main.*;
import javax.microedition.lcdui.*;

public class UserNameInput extends Form implements CommandListener, Localizable
{
    private TextField   m_txtName   = new TextField("", "", 256, TextField.ANY);
    private Command     m_cmdOK     = new Command("OK", Command.SCREEN, 0);
    private Command     m_cmdCancel;
    private Tetris      m_objApplication;
    private Localizer   m_objLocalizer;
    
    public UserNameInput(Tetris objApplication, Localizer objLocalizer)
    {
        super("");
        
        m_objApplication = objApplication;
        m_objLocalizer = objLocalizer;
        append(m_txtName);
        
        addCommand(m_cmdOK);
        setCommandListener(this);
    }
    
    public void commandAction(Command       cmd,
                              Displayable   d)
    {
        if (cmd == m_cmdCancel)
            m_objApplication.enterMenu();
        else if (cmd == m_cmdOK)
            m_objApplication.addUserNameToScoresTable(m_txtName.getString());
    }
    
    public void localize()
    {
        if (m_cmdCancel != null)
            removeCommand(m_cmdCancel);
        m_cmdCancel = new Command(m_objLocalizer.get(Localizer.S_CANCEL), Command.CANCEL, 1);
        addCommand(m_cmdCancel);
        setTitle(m_objLocalizer.get(Localizer.S_ENTER_NAME));
    }
    
    public void setApplicationObject(Tetris objApplication)
    {
        m_objApplication = objApplication;
    }
    
    public void setScoresPosition(int nPosition)
    {
        m_txtName.setLabel(m_objLocalizer.getPositionText(nPosition));
        m_txtName.setString("");
    }
}