/* Lehasoft Tetris Mobile 2006
   Copyright (c) Alexey Inkin, Lehasoft (1996-2006), GetSoft.ru, leha@inkin.ru

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  */

package Main;

import java.io.*;
import javax.microedition.rms.*;

class ParamsKeeper
{
    private RecordStore         m_objRecordStore;
    private RecordEnumeration   m_objEnumeration;
    
    public ParamsKeeper()
    {
        try
        {
            m_objRecordStore = RecordStore.openRecordStore("Lehasoft Tetris", true);
            m_objEnumeration = m_objRecordStore.enumerateRecords(null, null, true);
        }
        catch (Exception e)
        {
            System.out.println(e);
        }
    }
    
    public boolean deleteParam(String strParamName)
    {
        ByteArrayInputStream    bais;
        DataInputStream         dis;
        int                     nRecordID;
        
        try
        {
            m_objEnumeration.reset();
            while (m_objEnumeration.hasNextElement())
            {
                nRecordID = m_objEnumeration.nextRecordId();
                bais = new ByteArrayInputStream(m_objRecordStore.getRecord(nRecordID));
                dis = new DataInputStream(bais);
                if (dis.readUTF().equals(strParamName))
                {
                    m_objRecordStore.deleteRecord(nRecordID);
                    return true;
                }
            }
        }
        catch (Exception e)
        {
            System.out.println(e);
        }
        return false;
    }
    
    public String getParam(String   strParamName,
                           String   strDefaultValue)
    {
        ByteArrayInputStream    bais;
        DataInputStream         dis;
        String                  str;
        
        try
        {
            m_objEnumeration.reset();
            while (m_objEnumeration.hasNextElement())
            {
                bais = new ByteArrayInputStream(m_objEnumeration.nextRecord());
                dis = new DataInputStream(bais);

                str = dis.readUTF();
                if (str.equals(strParamName))
                    return dis.readUTF();
            }
            return strDefaultValue;
        }
        catch (Exception e)
        {
            System.out.println(e);
            return null;
        }
    }
    
    public void setParam(String strParamName,
                         String strValue)
    {
        ByteArrayInputStream    bais;
        DataInputStream         dis;
        ByteArrayOutputStream   baos;
        DataOutputStream        dos;
        int                     nRecordID;
        String                  str;
        
        try
        {
            m_objEnumeration.reset();
            while (m_objEnumeration.hasNextElement())
            {
                nRecordID = m_objEnumeration.nextRecordId();
                bais = new ByteArrayInputStream(m_objRecordStore.getRecord(nRecordID));
                dis = new DataInputStream(bais);

                str = dis.readUTF();
                if (str.equals(strParamName))
                {
                    m_objRecordStore.deleteRecord(nRecordID);
                    break;
                }
            }
            baos = new ByteArrayOutputStream();
            dos = new DataOutputStream(baos);
            dos.writeUTF(strParamName);
            dos.writeUTF(strValue);
            m_objRecordStore.addRecord(baos.toByteArray(), 0, baos.size());
        }
        catch (Exception e)
        {
            System.out.println(e);
        }
    }
}